package org.jeecg.modules.ctop.controller;

import com.alibaba.fastjson.JSONObject;
import org.jeecg.common.util.DateUtils;
import org.jeecg.common.util.ResultMapUtils;
import org.jeecg.common.util.StatusCode;
import org.jeecg.modules.ctop.entity.CTopOauthToken;
import org.jeecg.modules.ctop.service.ICTopOauthTokenService;
import org.jeecg.modules.ctop.service.IReportService;
import org.jeecg.modules.kuaishou.service.IKuaishouInterfaceService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.*;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

@RestController
@RequestMapping("report")
public class ReportController {
    @GetMapping("advertiser")
//    public Map<String, Object> advertiserReport(@RequestBody JSONObject conditions) {
    public Map<String, Object> advertiserReport() {
        JSONObject conditions = new JSONObject();
        return reportService.getAdvertiserReport(conditions);
    }

    @GetMapping("campaign")
//    public Map<String, Object> campaignReport(@RequestBody JSONObject conditions) {
    public Map<String, Object> campaignReport() {
        JSONObject conditions = new JSONObject();
        return reportService.getCampaignReport(conditions);
    }

    @GetMapping("ad")
    public Map<String, Object> adReport(@RequestBody JSONObject conditions) {
        return reportService.getAdReport(conditions);
    }

    @GetMapping("creative")
    public Map<String, Object> creativeReport(@RequestBody JSONObject conditions) {
        return reportService.getCreativeReport(conditions);
    }

    @GetMapping("agent")
    public Map<String, Object> agentReport(@RequestBody JSONObject conditions) {
        return reportService.getAgentReport(conditions);
    }

    /**
     * 360借条报表数据
     */
    @GetMapping("jietiao/kuaishou/insert")
    public Map<String, Object> jietiaoKuaishouInsert(String accountId) {
        Map<String, Object> result = new HashMap<>();
        CTopOauthToken token = tokenService.getOauthTokenByAccountId(accountId);
        Date now = new Date();
        String startDate = DateUtils.formatDate(now, "yyyy-MM-dd");
        kuaishouInterfaceService.getCampaignDailyReport(token.getAccessToken(), token.getAccountId(), startDate, startDate, 1000, 1);
        return result;
    }

    @Autowired
    private ICTopOauthTokenService tokenService;
    @Autowired
    private IKuaishouInterfaceService kuaishouInterfaceService;

    /**
     * 360借条报表客户后台数据
     */
    @GetMapping("jietiao/customer/insert")
    public Map<String, Object> jietiaoCustomerInsert() {
        Map<String, Object> result = new HashMap<>();
        String csvPath = "D:\\工作文件\\360借条\\测试数据\\客户后台数据.csv";
        reportService.insertCustomerInfo(csvPath, "utf8");
        ResultMapUtils.setResultMap(result, StatusCode.COMMON_SUCCESS.getCode());
        return result;
    }

    /**
     * 360借条报表平台数据
     */
    @GetMapping("jietiao/plateform/insert")
    public Map<String, Object> jietiaoPlatformInsert() {
        Map<String, Object> result = new HashMap<>();
        String csvPath = "D:\\工作文件\\360借条\\测试数据\\快手后台数据.csv";
        reportService.insertPlatformInfo(csvPath, "gb2312", 4L);
        ResultMapUtils.setResultMap(result, StatusCode.COMMON_SUCCESS.getCode());
        return result;
    }

    @PostMapping("debitAuto")
    Map<String, Object> debitAuto(@RequestBody JSONObject data) {
        return reportService.debitAuto(data);
    }

    @GetMapping("download/file")
    public void downLoadFile(String path, HttpServletResponse response) {
        try {
            File file = new File(path);
            InputStream fis = new BufferedInputStream(new FileInputStream(file));
            byte[] buffer = new byte[fis.available()];
            fis.read(buffer);
            fis.close();
            response.reset();
            // 设置response的Header
            response.addHeader("Content-Length", "" + file.length());
            response.setContentType("text/csv");
            response.setHeader("Content-Disposition", "attachment;fileName=template.xlsx");

            OutputStream toClient = new BufferedOutputStream(response.getOutputStream());
            toClient.write(buffer);
            toClient.flush();
            toClient.close();
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }

    @Autowired
    private IReportService reportService;
}
