package org.jeecg.modules.ctop.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecgframework.poi.excel.annotation.Excel;

/**
 * @Description: 关联用户分配
 * @Author: jeecg-boot
 * @Date: 2019-07-31
 * @Version: V1.0
 */
@Data
@TableName("ctop_auth_task")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_auth_task对象", description = "关联用户分配")
public class AuthTask {

    /**
     * 主键ID
     */
    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "主键ID")
    private Long id;
    /**
     * 广告主ID
     */
    @Excel(name = "广告主ID", width = 15)
    @ApiModelProperty(value = "广告主ID")
    private String advertiserId;
    /**
     * task_id
     */
    @Excel(name = "task_id", width = 15)
    @ApiModelProperty(value = "task_id")
    private String taskId;
}
