package org.jeecg.modules.ctop.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import org.jeecg.modules.ctop.entity.AuthTask;
import org.jeecg.modules.ctop.entity.CTopOauthToken;
import org.jeecg.modules.ctop.mapper.AuthTaskMapper;
import org.jeecg.modules.ctop.service.IAuthTaskService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

/**
 * @Description: 关联用户分配
 * @Author: jeecg-boot
 * @Date: 2019-07-31
 * @Version: V1.0
 */
@Service
public class AuthTaskServiceImpl extends ServiceImpl<AuthTaskMapper, AuthTask> implements IAuthTaskService {

    @Autowired
    private AuthTaskMapper authTaskMapper;

    @Override
    public AuthTask getAuthTask(String taskId) {
        QueryWrapper<AuthTask> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("task_id", taskId).orderByDesc("create_time");
        AuthTask authTask = authTaskMapper.selectOne(queryWrapper);
        return authTask;
    }
}
