package org.jeecg.modules.kuaishou.service.impl;

import cn.com.ctop.common.utils.Check;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import constant.KuaishouInterfaceConstant;
import org.jeecg.modules.kuaishou.entity.KuaiShouCreateAppTemplate;
import org.jeecg.modules.kuaishou.mapper.KuaiShouCreateAppTemplateMapper;
import org.jeecg.modules.kuaishou.service.IKuaiShouCreateAppTemplateService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.Map;

/**
 * @Description: 创建应用
 * @Author: jeecg-boot
 * @Date: 2019-08-06
 * @Version: V1.0
 */
@Service
public class KuaiShouCreateAppTemplateServiceImpl extends ServiceImpl<KuaiShouCreateAppTemplateMapper, KuaiShouCreateAppTemplate> implements IKuaiShouCreateAppTemplateService {
    @Autowired
    private KuaiShouCreateAppTemplateMapper appTemplateMapper;

    @Override
    public Map<String, Object> insert(KuaiShouCreateAppTemplate appTemplate) {
        Map<String, Object> resultMap = new HashMap<>();
        try {
            if (!Check.isNull(appTemplate.getFile())) {
                appTemplate.setFile(KuaishouInterfaceConstant.HTTPS_PREFIX + appTemplate.getFile());
            }
            if (!Check.isNull(appTemplate.getImageUrl())) {
                appTemplate.setImageUrl(KuaishouInterfaceConstant.HTTPS_PREFIX + appTemplate.getImageUrl());
            }
            appTemplateMapper.insert(appTemplate);
            resultMap.put("success", true);
            resultMap.put("message", "创建广告创意成功");
            resultMap.put("code", 0);
        } catch (Exception e) {
            resultMap.put("success", false);
            resultMap.put("message", "创建广告创意失败");
            resultMap.put("code", -1);
        }
        return resultMap;

    }
}
