package org.jeecg.modules.kuaishou.service.impl;

import cn.com.ctop.common.utils.Check;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import constant.KuaishouInterfaceConstant;
import org.jeecg.common.util.encryption.AesEncryptUtil;
import org.jeecg.modules.kuaishou.entity.KuaiShouVideo;
import org.jeecg.modules.kuaishou.mapper.KuaiShouVideoMapper;
import org.jeecg.modules.kuaishou.service.IKuaiShouVideoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @Description: 快手-本地图片保存
 * @Author: jeecg-boot
 * @Date: 2019-08-14
 * @Version: V1.0
 */
@Service
public class KuaiShouVideoServiceImpl extends ServiceImpl<KuaiShouVideoMapper, KuaiShouVideo> implements IKuaiShouVideoService {
    @Autowired
    private KuaiShouVideoMapper kuaiShouVideoMapper;

    @Override
    public void insert(JSONObject requestJson) throws Exception {
        if (Check.isNull(requestJson)) {
            throw new Exception("传递参数不能为空");
        }
        JSONArray localArr = requestJson.getJSONArray("localUrl");
        if (!Check.isNull(localArr)) {
            for (int i = 0; i < localArr.size(); i++) {
                KuaiShouVideo video = new KuaiShouVideo();
                video.setVideoDesc(requestJson.getString("videoDesc"));
                String url = localArr.get(i).toString();
                String fileName = url.substring(url.lastIndexOf("/") + 1);
                String fileNameStr = null;
                if (!Check.isNull(fileName)) {
                    String[] split = fileName.split("-");
                    fileNameStr = split[0];
                }
                video.setLoginId(requestJson.getString("loginId"));
                video.setVideoName(AesEncryptUtil.getURLDecoderString(fileNameStr));
                video.setLocalUrl(KuaishouInterfaceConstant.HTTPS_PREFIX + url);
                video.setMaterialType(requestJson.getString("materialType"));
                kuaiShouVideoMapper.insert(video);
            }
        }

    }

    @Override
    public String localInsert(JSONObject requestJson) throws Exception {

        String url = null;
        String videoUrl = requestJson.getString("videoUrl");
        if (!Check.isNull(videoUrl)) {

            KuaiShouVideo video = new KuaiShouVideo();
            video.setVideoDesc(requestJson.getString("description"));
            String fileName = videoUrl.substring(videoUrl.lastIndexOf("/") + 1);
            String fileNameStr = null;
            if (!Check.isNull(fileName)) {
                String[] split = fileName.split("-");
                fileNameStr = split[0];
            }
            url = KuaishouInterfaceConstant.HTTPS_PREFIX + videoUrl;
            video.setLocalUrl(url);
            video.setLoginId(requestJson.getString("loginId"));
            video.setMaterialType(requestJson.getString("videoType"));
            video.setVideoName(AesEncryptUtil.getURLDecoderString(fileNameStr));


            kuaiShouVideoMapper.insert(video);

        }

        return url;
    }

}
